# include <cstdio>
# include <cmath>
# define MAXN (1<<10)
# define max(a,b) (((a)>(b))? (a):(b))
# define EP 1e-10

using namespace std;

unsigned short data[MAXN][MAXN];
unsigned short query[MAXN][MAXN][11];
int n,m;

void readf() {
    scanf("%d %d",&n,&m);
    for ( int i=0 ; i<n ; ++i )
	for ( int j=0 ; j<m ; ++j ) {
	    scanf("%hu",&data[i][j]);
	    query[i][j][0] = data[i][j];
	}    
}

void precompute() {
    int sq = 1, sq2=1;
    unsigned short buf=0,buf2=0;
    for ( int i=1 ; i<10 ; ++i ) {
	sq *= 2;
	for ( int j=0 ; j<n-sq+1 ; ++j ) {
	    for ( int l=0 ; l<m-sq+1 ; ++l ) {
		buf = query[j][l][i-1];
		buf2 = query[j][l+sq2][i-1];
		buf = max(buf,buf2);
		buf2 = query[j+sq2][l][i-1];
		buf = max(buf,buf2);
		buf2 = query[j+sq2][l+sq2][i-1];
		query[j][l][i] = max(buf,buf2);
	    }
	}
	sq2 *= 2;
    }    
}

void answer() {
    int l;
    scanf("%d",&l);
    unsigned short x,y,size,logsize;
    unsigned short buf=0,buf2=0,a;
    while (l) {
	scanf("%hu %hu %hu",&x,&y,&size);
	logsize = (int)(log((double)size)/log(2.0)+EP);
	a = size-(1<<logsize);
	buf = query[x][y][logsize];
	buf2 = query[x][y+a][logsize];
	buf = max(buf,buf2);
	buf2 = query[x+a][y][logsize];
	buf = max(buf,buf2);
	buf2 = query[x+a][y+a][logsize];
	printf("%hu\n",max(buf,buf2));
	l--;
    }
}

int main() {
    readf();
    precompute();
    answer();

    return 0;
}
