#include <stdio.h>
#include <stdlib.h>
#include <string.h>
typedef enum {integer, real, string} Type;
int N;
char line[1024];
int count=0,dayoff[101]={0};
long n;
int checkLine(void)
{char *p=line,*end;
 int couple[100][2],cnt=0,i,playing[101]={0};
 long pl1,pl2;
 while(*p)
 {pl1=strtol(p,&end,10);
  if (*end!='-') return 0;
  if (pl1<1||pl1>n) return 0;
  p=end+1;
  pl2=strtol(p,&end,10);
  if (*end&&*end!=' ') return 0;
  if (pl2<1||pl2>n) return 0;
  for (i=0;i<cnt;i++)
   if (couple[i][0]==pl1||couple[i][1]==pl2||
       couple[i][0]==pl2&&couple[i][1]==pl1) return 0;
  couple[cnt][0]=(int)pl1;
  couple[cnt][1]=(int)pl2;
  cnt++;
  count++;
  playing[pl1]++;
  playing[pl2]++;
  p=end;
  if (*p) p++;
 }
 for (i=1;i<=n;i++) if (!playing[i]<2) dayoff[i]++;
 return 1;
}
int freadline(Type t, FILE *f, char *b, int size)
{int i;
 char *e;
 b[0]=0;
 fgets(b,size,f);
 for (i=0;i<size&&b[i]&&b[i]!='\n';i++);
 b[i]=0;
 switch (t)
 {case string:return 1;
  case integer:{strtol(b,&e,10);
		return *b&&!*e;
	       }
  case real:{strtod(b,&e);
	     return *b&&!*e;
	    }
 }
 return 0;
}

int main(int argc, char **argv)
{FILE *fin, *fcomp;
 int i;
 char *e;
 if (argc!=4)
 {printf("Argument error\n");
  return 0;
 }
 if (!(fin = fopen(argv[1], "r")))      // input file
 {printf("Cannot open input.\n");
  return 0;
 }
 if (!freadline(integer,fin,line,6))
 {printf("Wrong input.\n");
  return 0;
 }
 fclose(fin);
 N=strtol(line,&e,10);
 if(N<1||N>100)
 {printf("Wrong input.\n");
  return 0;
 }
 if (!(fcomp = fopen(argv[2], "r")))    // competitor file
 {printf("0\nCannot open result.\n");
  fclose(fin);
  return 0;
 }
 if (!freadline(integer,fcomp,line,10))
 {printf("0\nIncorrect line.\n");
  return 0;
 }
 n=strtol(line,&e,10);
 if (N!=n)
 {fclose(fcomp);
  printf("0\nIncorrect count.\n");
  return 0;
 }
 for (i=1;i<=n;i++)
 {freadline(string,fcomp,line,1000);
  if (!checkLine()) {printf("0\nBad day #%d:\n%s\n",i,line);return 0;}
 }
 if (count!=n*(n-1)){printf("0\nMissing match(es)\n");return 0;}
 for (i=1;i<=n;i++) if (!dayoff[i]){printf("0\nPlayer #%d has no day off\n",i);return 0;}
 printf("10\nCorrect\n");
 return 0;
}